<script setup lang="ts">
import { api_call } from "@/functions";
import { reactive, watch, computed } from "vue";
import type { API_FileList, API_File } from "@/types";

const state = reactive<{ files: API_FileList; selected_file: API_File | null }>(
  {
    files: [], // Init empty file lists
    selected_file: null,
  }
);

const emit = defineEmits<{
  (e: "selectionchange", file: API_File | null): void;
}>();

// "export" for using from the outside and trigger update
defineExpose({
  load_ocel_files,
  select_file,
});

// Execute on load:
load_ocel_files();

// Loads ocel files from api. Sets selected_file accordingly (auto to the first)
async function load_ocel_files() {
  const old_selected_file = state.selected_file;
  const response = await api_call("/ocel-upload", "GET");
  let old_found = false;
  state.files = (await response.json()).data;
  // If old_selected_file is not null search for the old. If found, leave the selected_file property as it is.
  if (!(old_selected_file == null)) {
    for (const index in state.files) {
      if (state.files[index].id == old_selected_file.id) {
        old_found = true;
        break;
      }
    }
  }
  if (!old_found) {
    if (state.files.length > 0)
      state.selected_file = state.files[0]; // not found -> set to first element
    else state.selected_file = null; // no possible files -> set to null
  }
  return;
}

function select_file(file_id: string) {
  if (state.selected_file != null && file_id != state.selected_file.id) {
    // Only if a change is needed
    for (const index in state.files) {
      if (state.files[index].id == file_id) {
        state.selected_file = state.files[index];
        break;
      }
    }
  }
}

async function delete_file(file_id: string) {
  const response = await api_call("/ocel-upload/" + file_id, "DELETE");
  if (response.status == 200) {
    await load_ocel_files(); // Full Update
    return true;
  }
  throw Error("File " + file_id + " was not succesfully deleted.");
}

const isEmpty = computed(() => {
  return state.files.length <= 0;
});

// Fire event once a different file is selected.
watch(
  () => state.selected_file,
  (new_file) => {
    emit("selectionchange", new_file);
  }
);
</script>

<template>
  <div class="text-light" v-if="isEmpty">No files!</div>
  <div v-if="!isEmpty" class="list-group">
    <a
      v-for="file in state.files"
      :key="file.id"
      class="list-group-item list-group-item-action"
      :class="{
        active: state.selected_file ? file.id == state.selected_file.id : false,
      }"
      href="#"
      @click.prevent="select_file(file.id)"
    >
      <div class="d-flex w-100 justify-content-between">
        <span class="align-self-center">{{ file.id }}</span>
        <button class="btn btn-danger btn-sm" @click="delete_file(file.id)">
          Delete
        </button>
      </div>
    </a>
  </div>
</template>
